#include <linux/version.h>

#if LINUX_VERSION_CODE < 132630

#define IPPROTO_UDPLITE 136

static inline struct iphdr *
ip_hdr(const struct sk_buff *skb)
{
        return skb->nh.iph;
}

static inline struct ipv6hdr *
ipv6_hdr(const struct sk_buff *skb)
{
        return skb->nh.ipv6h;
}

static inline psched_time_t
psched_get_time(void)
{
        psched_time_t now;
        PSCHED_GET_TIME(now);
        return now;
}

static inline psched_tdiff_t
psched_tdiff_bounded(psched_time_t tv1, psched_time_t tv2, psched_time_t bound)
{
        psched_tdiff_t diff;
        diff = tv1 - tv2;
        if(diff >= bound)
                return bound;
        else
                return diff;
}

#define PSCHED_TICKS_PER_SEC 1000000L

#define qdisc_create_dflt(dev, ops, partentid) (qdisc_create_dflt)((dev), (ops))

static inline void qdisc_tree_decrease_qlen(struct Qdisc *qdisc, unsigned int n)
{
    return;
}

#endif
